;;MR45.LSP Copyright 1997 HyperPics all rights reserved
;;
;;  Author: Lee Ambrosius,
;;             HyperPics

;;  Mirror 45
;;  Allows the user to Mirror object(s) around any point given
;; 
;;  All documentation must stay with this Lips routine though.

;; Convert Degrees to Radians
(defun DTR (deg)
   (* deg (/ PI 180))
)

;; Error Tile
(defun MYERROR (S)                    ;;error trap program
   (if (/= S "\nFunction cancelled" )
   (princ "\nEnding Mirror45..." ) )
   (setvar "cmdecho" CMD)
   (setvar "snapang" SANG)
   (setq *ERROR* OLDERR )
  (princ) 
)

;; Mirror 45 Command
(defun c:MR45 ()
    (setq SANG (getvar "snapang"))
    (setq CMD (getvar "cmdecho"))
    (setvar "cmdecho" 1)
    (setq OLDERR *ERROR*)
    (setq *ERROR* MYERROR )
    (terpri)
    (prompt "\nMirror 45 activated....")
    (setq SS(ssget))
    (setq NANG (getstring "\nEnter Angle to Rotate: "))  ;; Get angle user desires
   (if (null NANG)
       (setq NANG "0")
   )
   (setq NANG (atof NANG))   ;; Convert to a real number
    (setq NANG(DTR NANG))
    (setq PT1(getpoint "\nPick Insertion Point: "))
    (terpri)
    (setvar "snapang" NANG)
    (command "_mirror" SS "" PT1 pause pause)   
    (prompt "\nExiting Mirror 45.")
    (setvar "cmdecho" CMD)
    (setvar "snapang" SANG)
    (redraw)
  (princ)
)
(c:MR45)
